﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Data;

namespace ServeiWeb
{
    public class Incidencia
    {
        //Estats Incidència
        public const string INC_ESTAT_PEND = "PENDENT";
        public const string INC_ESTAT_TANC = "TANCADA";
        public const string INC_ESTAT_CANC = "CANCEL·LADA";

        private DataTable _dtUsu = new DataTable();
        private GestorSql _gestSql = new GestorSql();
        private SqlDataReader _sqlDtRIncPend;

        private string _taula;
        private string _camps;
        private string _filtre;

        private string _select;

        private int _codIncidencia;
        private string _sistema;
        private string _adreça;

        public int CodIncidencia
        {
            get { return _codIncidencia; }
            set { _codIncidencia = value; }
        }


        public String Sistema
        {
            get { return _sistema; }
            set { _sistema = value; }
        }

        public String Adreça
        {
            get { return _adreça; }
            set { _adreça = value; }
        }


        //Actualitza l'estat d'una incidència
        public Boolean ActEstatInc(int iCodInc, string sNouEst, string sMotiuCancel = "")
        {

            _select = "SELECT Usuaris.login FROM Usuaris INNER JOIN " +
                    "Incidencies ON Usuaris.codUsuari = Incidencies.codTecnic " +
                    "WHERE  Incidencies.codIncidencia=" + iCodInc;

            _dtUsu = _gestSql.ExecutarSql(_select).Tables[0];

            DataRow dr = _dtUsu.Rows[0];
            string _sUsuari = (string)dr["login"];
            
            _taula = "Incidencies";
            _filtre = "codIncidencia=" + iCodInc;

            if (sNouEst == INC_ESTAT_TANC)
            {
                _camps = "estat='" + sNouEst + "'," + "data_tancament='" + DateTime.Today + "', usuari_tancament ='" + _sUsuari + "' ";

            }

            if (sNouEst == INC_ESTAT_CANC)
            {
                _camps = "estat='" + sNouEst + "'," + "data_cancel='" + DateTime.Today + "', " +
                          "observacions_cancel='" + sMotiuCancel + "', usuari_cancel ='" + _sUsuari + "' ";
            }

            try
            {
                _gestSql.Modificar(_taula, _camps, _filtre);
                return true;
            }
            catch (Exception)
            {
                return false;
            }


        }


        //Carrega en una col·lecció les incidències pendents associades al tècnic autenticat
        public List<Incidencia> IncidenciesPendTec(int idTecnic)
        {

            List<Incidencia> lIncPen = new List<Incidencia>();

            _select = "SELECT Incidencies.codIncidencia, SistemesEnllumenat.sistema, Incidencies.adreça " +
                      "FROM SistemesEnllumenat INNER JOIN Incidencies ON " +
                      "Incidencies.codSistema = SistemesEnllumenat.codSistema INNER JOIN " +
                      "Usuaris ON Incidencies.codTecnic = Usuaris.codUsuari " +
                      "WHERE Incidencies.codTecnic =" + idTecnic + " AND Incidencies.estat = '" + INC_ESTAT_PEND + "' ";

            _sqlDtRIncPend = _gestSql.ObtDataReader(_select);
            while (_sqlDtRIncPend.Read())
            {
                Incidencia novaInc = new Incidencia();
                novaInc._codIncidencia = _sqlDtRIncPend.GetInt32(0);
                novaInc._sistema = _sqlDtRIncPend.GetString(1);
                novaInc._adreça = _sqlDtRIncPend.GetString(2);
                lIncPen.Add(novaInc);
            }

            return lIncPen;


        }
    }
}