﻿Imports System.IO.IsolatedStorage
Imports System.Xml.Serialization

Public Class ControlAcces

    Private Sub btnSortir_Click(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnSortir.Click
        Environment.Exit(0)
    End Sub

    Private Sub btnAccedir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnAccedir.Click

        'Valida l'usuari i la contrasenya introduïdes

        Dim finestra_principal As PantallaPrincipal = New PantallaPrincipal
        Dim restablir_contrasenya As RestablirContrasenya = New RestablirContrasenya

        If DadesCorrectes() Then
            Try
                CarregarUsuariActiu()

                'Només podrà accedir a l'aplicació si l'usuari està actiu i té
                'perfil d'Oficinista o d'Administrador 

                If DateTime.Compare(usuariAct.Data_Baixa, DateTime.MinValue) <> 0 Or usuariAct.TePerfil(TEC) Then
                    MessageBox.Show _
                         ("L'usuari no pot accedir", "Error d'Accés", MessageBoxButton.OK, MessageBoxImage.Error)
                    txtUsuari.Clear()
                    txtPassword.Clear()
                    txtUsuari.Focus()

                    'Si el login i password són iguals a la BBDD, això implica que l'usuari ha de canviar la contrasenya
                    'Si l'usuari introdueix un login i contrasenya iguals, però no estan a la BBDD, NO ha de mostrar el
                    'missatge de canvi de contrasenya
                ElseIf usuariAct.Login = usuariAct.Password And (usuariAct.Login <> "" Or usuariAct.Password <> "") Then
                    MessageBox.Show _
                            ("Ha de canviar la contrasenya", "Canvi de contrasenya", MessageBoxButton.OK, MessageBoxImage.Information)

                    'Passem l'usuari a la classe RestablirContrasenya
                    restablir_contrasenya._usuari = txtUsuari.Text

                    txtPassword.Clear()
                    restablir_contrasenya.Show()

                ElseIf usuariAct.TePerfil(OFI) Or usuariAct.TePerfil(ADM) Then
                    Me.Close()
                    finestra_principal.Show()

                Else
                    MessageBox.Show _
                      ("Usuari o clau incorrecta.", "Accés Incorrecte", MessageBoxButton.OK, MessageBoxImage.Error)

                End If

            Catch ex As Exception
                MessageBox.Show _
                  (ex.Message, "Accés Incorrecte", MessageBoxButton.OK, MessageBoxImage.Error)

            End Try
        End If
    End Sub

    'Carrega les dades de l'usuari que inicia la sessió
    Private Sub CarregarUsuariActiu()

        usuariAct = New Usuaris()
        usuariAct.Buscar(txtUsuari.Text, txtPassword.Password)

    End Sub

    'Comprova si s'ha introduït el nom d'usuari i la contrasenya
    Private Function DadesCorrectes() As Boolean
        DadesCorrectes = False

        If String.IsNullOrEmpty(txtUsuari.Text) Then
            MessageBox.Show _
                  ("Si us plau, introdueixi el nom d'usuari", "Accés Incorrecte", MessageBoxButton.OK, MessageBoxImage.Information)
            txtUsuari.Focus()
            Exit Function
        End If

        If String.IsNullOrEmpty(txtPassword.Password) Then
            MessageBox.Show _
              ("Si us plau, introdueixi la contrasenya", "Accés Incorrecte", MessageBoxButton.OK, MessageBoxImage.Information)
            txtPassword.Focus()
            Exit Function
        End If

        DadesCorrectes = True

    End Function

    Private Sub ControlAcces_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        txtUsuari.Focus()
    End Sub
End Class
