﻿Imports System.Data

Public Class FitxaIncidencia

    Private ReadOnly _sistema As New SistemesEnllumenat
    Private ReadOnly _incidencia As New Incidencies
    Private ReadOnly _usuari As Usuaris = New Usuaris
    Private _carregant As Boolean
    Private _codIncidencia As Integer
    Private _era_baixa As Boolean
    Private _dadescomboUsuaris As DataRowView
    Private _dtUsuari As DataTable
    Private _dtSistema As DataTable
    Private _dadesfila As DataRowView
    Private _filtreTecnic As String

    Public Sub Carregar(Optional ByVal codIncidencia As Integer = 0)

        _codIncidencia = codIncidencia

        CarregarFinestra()
        Me.ShowDialog()

    End Sub

    Private Sub CarregarFinestra()

        If _codIncidencia <> 0 Then
            'Modificació
            CarregaDades()
        Else
            'Nou
            BuidarDades()
        End If

    End Sub

    Private Sub BuidarDades()

        txtCodi.Text = ""
        txtCp.Text = ""
        txtAdreça.Text = ""
        dataObertura.SelectedDate = DateTime.Now.Date
        txtUsuariAlta.Text = usuariAct.Login
        dataTancament.SelectedDate = DATA_NULL
        txtUsuariTanc.Text = ""
        dataCancel.SelectedDate = DATA_NULL
        txtUsuariCancel.Text = ""
        txtObsCancel.Text = ""
        txtEstat.Text = INC_ESTAT_PEND

        CarregarComboSistema()
        CarregarComboTecnic()

    End Sub

    Private Sub CarregaDades()

        _carregant = True
        _filtreTecnic = ""

        With _incidencia
            .Buscar(_codIncidencia)

            txtCodi.Text = .codIncidencia

            'Carreguem els sistemes al combo
            CarregarComboSistema()
            'Busquem el Sistema que té per codi l'emmagatzemat al camp codSistema de la taula
            _dtSistema = _sistema.ObtenirSistema("s.codSistema=" & .codSistema)
            'Sabem que en la taula retornada, el camp 0 és codSistema i l'1 és el nom del Sistema
            cboSistema.Text = _dtSistema.Rows(0)(1)

            txtCp.Text = .cp
            txtAdreça.Text = .Adreça
            dataObertura.SelectedDate = .data_Alta

            'Busquem el gestor que té per codi l'emmagatzemat al camp usuari_alta de la taula
            _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.codUsuari=" & .codGestor)
            txtUsuariAlta.Text = _dtUsuari.Rows(0)(5)

            If DateTime.Compare(.data_Tancament, DateTime.MinValue) <> 0 Then
                dataTancament.SelectedDate = .data_Tancament
            End If

            txtUsuariTanc.Text = .usuari_Tancament

            If DateTime.Compare(.data_Cancel, DateTime.MinValue) <> 0 Then
                dataCancel.SelectedDate = .data_Cancel
            End If

            txtUsuariCancel.Text = .usuari_Cancel
            txtObsCancel.Text = .Obs_Cancel
            txtEstat.Text = .Estat

            'Carreguem els usuaris al combo
            CarregarComboTecnic()
            'Busquem el Tècnic que té per codi l'emmagatzemat al camp codTecnic de la taula
            _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.codUsuari=" & .codTecnic)
            'Sabem que en la taula retornada, el camp 5 és el del login
            cboTecnic.Text = _dtUsuari.Rows(0)(5)

            'Si l'estat és TANCADA no es podrà canviar cap dada
            If .Estat = INC_ESTAT_TANC Then
                btnGuardar.IsEnabled = False
                cboSistema.IsEnabled = False
                txtAdreça.IsEnabled = False
                txtCp.IsEnabled = False
                txtObsCancel.IsEnabled = False
                cboTecnic.IsEnabled = False
                txtEstat.Background = Brushes.LimeGreen
                btnReobrir.IsEnabled = False
            End If

            If .Estat = INC_ESTAT_PEND Then
                btnReobrir.IsEnabled = False
            End If

            If .Estat = INC_ESTAT_CANC Then
                txtEstat.Background = Brushes.Red
            End If

        End With

        _carregant = False

    End Sub

    Private Sub CarregarComboSistema()

        Dim oSistema As New SistemesEnllumenat

        'Carreguem el combo amb les dades de la taula SistemesEnllumenat
        cboSistema.ItemsSource = oSistema.ObtenirSistemaCbo("data_baixa is null").DefaultView
        cboSistema.DisplayMemberPath = "sistema"
        cboSistema.SelectedValuePath = "codSistema"

    End Sub

    Private Sub CarregarComboTecnic()

        Dim oUsuaris As New Usuaris

        _filtreTecnic = "up.codPerfil=" & ID_TEC

        cboTecnic.ItemsSource = oUsuaris.ObtenirUsuariCbo(_filtreTecnic).DefaultView
        cboTecnic.DisplayMemberPath = "login"
        cboTecnic.SelectedValuePath = "codUsuari"

    End Sub

    Private Sub btnGuardar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnGuardar.Click

        If ComprovarDades() Then

            With _incidencia
                'Busquem el Sistema que té per codi l'emmagatzemat al combobox de Sistemes
                _dtSistema = _sistema.ObtenirSistema("s.sistema='" & cboSistema.Text & "' ")
                'Sabem que en la taula retornada, el camp 0 és codSistema i l'1 és el nom del Sistema
                .codSistema = _dtSistema.Rows(0)(0)

                .cp = txtCp.Text.Trim
                .Adreça = txtAdreça.Text.Trim
                .data_Alta = dataObertura.SelectedDate
                .Estat = txtEstat.Text.Trim

                'Busquem el gestor que té per login l'emmagatzemat al camp txtUsuariAlta de la finestra
                _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.login='" & txtUsuariAlta.Text.Trim & "' ")
                .codGestor = _dtUsuari.Rows(0)(0)

                .data_Tancament = IIf(IsNothing(dataTancament.SelectedDate), DateTime.MinValue, dataTancament.SelectedDate)
                .usuari_Tancament = txtUsuariTanc.Text.Trim
                .data_Cancel = IIf(IsNothing(dataCancel.SelectedDate), DateTime.MinValue, dataCancel.SelectedDate)
                .usuari_Cancel = txtUsuariCancel.Text.Trim

                'Busquem el tècnic que té per login l'emmagatzemat al combo de tècnics de la finestra
                _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.login='" & cboTecnic.Text & "' ")
                .codTecnic = _dtUsuari.Rows(0)(0)

                Try
                    .Gravar()
                    CanviarEstat()
                Catch ex As Exception
                    MessageBox.Show _
                    (ex.Message, "Error al guardar", MessageBoxButton.OK, MessageBoxImage.Error)
                End Try

            End With
            Close()

        End If

    End Sub

    Private Function ComprovarDades() As Boolean

        Try
            ComprovarCombo(cboSistema.Text, "el nom del sistema")
            Comprovar(txtCp, "el CP")
            Comprovar(txtAdreça, "l'adreça")
            ComprovarCombo(cboTecnic.Text, "el tècnic assignat")

        Catch ex As Exception
            MessageBox.Show _
              (ex.Message, "Incidència", MessageBoxButton.OK, MessageBoxImage.Information)

            Return False
        End Try

        Return True

    End Function

    Private Sub Comprovar(ByRef oControl As TextBox, _
                                  ByVal sNomDada As String)

        If oControl.Text = "" Then
            oControl.Focus()
            Throw New Exception("Ha d'introduir " & sNomDada & ".")
        End If
    End Sub

    Private Sub ComprovarCombo(ByRef sValor As String, _
                               ByVal sNomDada As String)

        If sValor = "" Then
            Throw New Exception("Ha d'introduir " & sNomDada & ".")
        End If
    End Sub

    Private Sub CanviarEstat()
        Dim iRes As Integer

        'Si actualitzem la incidència y l'estat és cancel·lada, passa a pendent
        If _codIncidencia <> 0 And txtEstat.Text = INC_ESTAT_CANC Then

            iRes = MessageBox.Show _
              ("Si reobre la incidència actual passarà a tenir-ne estat ""PENDENT"". " & vbCrLf & _
               "Està segur que desitja reobrir-la? ", "Reobrir Incidència", _
              MessageBoxButton.YesNo, MessageBoxImage.Question)

            If iRes = vbYes Then
                _incidencia.CanviarEstat(_codIncidencia, INC_ESTAT_PEND)
                Me.Close()
            End If

        End If

    End Sub

    'Al CP només podrem introduir números
    Private Sub txtCP_KeyDown(sender As Object, e As System.Windows.Input.KeyEventArgs) Handles txtCp.KeyDown

        NomesNumeros(sender, e)

    End Sub

    Private Sub btnSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnSortir.Click

        Me.Close()

    End Sub

    Private Sub btnReobrir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnReobrir.Click

        CanviarEstat()

    End Sub

End Class
