﻿Imports System.Data

Public Class FitxaSistema

    Private ReadOnly _tipus As New TipusSistema
    Private ReadOnly _sistema As New SistemesEnllumenat
    Private _carregant As Boolean
    Private _codSistema As Integer
    Private _era_baixa As Boolean
    Private ReadOnly _usuari As Usuaris = New Usuaris
    Private _dtUsuari As DataTable
    Private _dtTipus As DataTable
    Private _dadesfila As DataRowView

    Public Sub Carregar(Optional ByVal codSistema As Integer = 0)

        _codSistema = codSistema

        CarregarFinestra()
        Me.ShowDialog()

    End Sub

    Private Sub CarregarFinestra()

        If _codSistema <> 0 Then
            'Modificació
            CarregaDades()
        Else
            'Nou
            BuidarDades()
        End If

    End Sub

    Private Sub BuidarDades()

        txtUsuariBaixa.Text = ""
        txtUsuariAlta.Text = usuariAct.Login
        cboSistema.IsEditable = True
        dataAlta.SelectedDate = DateTime.Now.Date

        CarregarComboTipus()

    End Sub

    Private Sub CarregaDades()

        _carregant = True

        With _sistema
            .Buscar(_codSistema)

            'Carreguem la dada del sistema al combo
            cboSistema.Items.Add(.Sistema)
            cboSistema.SelectedIndex = cboSistema.Items.Count - 1

            'Carreguem la dada del tipus al combo
            CarregarComboTipus()
            'Busquem el Tipus que té per codi l'emmagatzemat al camp codTipus de la taula
            _dtTipus = _tipus.ObtenirTipus("codTipus=" & .codTipus)
            'Sabem que en la taula retornada, el camp 0 és codTipus i l'1 és Tipus
            cboTipus.Text = _dtTipus.Rows(0)(1)

            dataAlta.SelectedDate = .Data_Alta

            If DateTime.Compare(.Data_Baixa, DateTime.MinValue) <> 0 Then
                dataBaixa.SelectedDate = .Data_Baixa
            End If

            'Busquem l'usuari que té per codi l'emmagatzemat al camp usuari_alta de la taula
            _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.codUsuari=" & .Usuari_Alta)
            txtUsuariAlta.Text = _dtUsuari.Rows(0)(5)

            txtUsuariBaixa.Text = .Usuari_Baixa

        End With

        'Comprovem si al carregar les dades, l'usuari ja està donat de baixa
        If IsNothing(dataBaixa.SelectedDate) Then
            _era_baixa = True
        ElseIf DateTime.Compare(dataBaixa.SelectedDate, DateTime.MinValue) = 0 Then
            _era_baixa = True
        Else
            _era_baixa = False
        End If

        _carregant = False

    End Sub

    Private Sub CarregarComboTipus()

        Dim oTipus As New TipusSistema

        'Carreguem el combo amb les dades de la taula TipusSistema
        cboTipus.ItemsSource = oTipus.ObtenirTipusCbo("usuari_baixa is null").DefaultView
        cboTipus.DisplayMemberPath = "tipus"
        cboTipus.SelectedValuePath = "codTipus"

    End Sub

    Private Sub btnGuardar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnGuardar.Click

        If ComprovarDades() Then

            With _sistema
                .codSistema = _codSistema
                .Sistema = cboSistema.Text
                .Data_Alta = dataAlta.SelectedDate
                .Data_Baixa = IIf(IsNothing(dataBaixa.SelectedDate), DateTime.MinValue, dataBaixa.SelectedDate)
                .Usuari_Baixa = txtUsuariBaixa.Text.Trim

                'Busquem l'usuari que té per login l'emmagatzemat al camp txtUsuariAlta de la finestra
                _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.login='" & txtUsuariAlta.Text.Trim & "' ")
                .Usuari_Alta = _dtUsuari.Rows(0)(0)

                'Busquem el tipus que té per nom l'emmagatzemat al combo de tipus de la finestra
                _dtTipus = _tipus.ObtenirTipus("TipusSistema.tipus='" & cboTipus.Text & "' ")
                'Sabem que en la taula retornada, el camp 0 és codTipus i l'1 és Tipus
                .codTipus = _dtTipus.Rows(0)(0)

                Try
                    .Gravar()
                Catch ex As Exception
                    MessageBox.Show _
                    (ex.Message, "Error al guardar", MessageBoxButton.OK, MessageBoxImage.Error)
                End Try

            End With
            Close()

        End If

    End Sub

    Private Function ComprovarDades() As Boolean

        Try
            ComprovarCombo(cboSistema.Text, "el nom del sistema")
            ComprovarCombo(cboTipus.Text, "el tipus de sistema")

            ComprovarSistemaExistent()

            CanviSistemaOK()

        Catch ex As Exception
            MessageBox.Show _
              (ex.Message, "Sistema", MessageBoxButton.OK, MessageBoxImage.Information)

            Return False
        End Try

        Return True

    End Function

    'Només la utilitzarem per mirar si es canvia un sistema amb incidències assignades
    Private Function CanviSistemaOK() As Boolean

        Dim canvi As Boolean = False
        Dim incidencies As Incidencies = New Incidencies

        If incidencies.AssociadaIncidencia("codSistema", _codSistema) Then
            Throw New Exception("No es pot modificar el sistema perquè està associat a alguna incidència oberta.")
        Else
            canvi = True
        End If

        Return canvi

    End Function

    Private Sub Comprovar(ByRef oControl As TextBox, _
                                  ByVal sNomDada As String)

        If oControl.Text = "" Then
            oControl.Focus()
            Throw New Exception("Ha d'introduir " & sNomDada & ".")
        End If
    End Sub

    Private Sub ComprovarCombo(ByRef sValor As String, _
                               ByVal sNomDada As String)

        If sValor = "" Then
            Throw New Exception("Ha d'introduir " & sNomDada & ".")
        End If
    End Sub

    Private Sub ComprovarSistemaExistent()
        If _sistema.DadaExistent("sistema", "'" & cboSistema.SelectedValue & "'") Then
            Throw New Exception("Ja existeix un sistema a la base de dades amb aquest nom.")
        End If
    End Sub

    Private Sub btnSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnSortir.Click

        Me.Close()

    End Sub

End Class
