﻿Imports System.Data

Public Class FitxaTipus

    Private ReadOnly _tipus As New TipusSistema
    Private _carregant As Boolean
    Private _codTipus As Integer
    Private _era_baixa As Boolean
    Private _dadescombo As DataRowView
    Private ReadOnly _usuari As Usuaris = New Usuaris
    Private _dtUsuari As DataTable
    Private _dadesfila As DataRowView

    Public Sub Carregar(Optional ByVal codTipus As Integer = 0)

        _codTipus = codTipus

        CarregarFinestra()
        Me.ShowDialog()

    End Sub

    Private Sub CarregarFinestra()

        If _codTipus <> 0 Then
            'Modificació
            CarregaDades()
        Else
            'Nou
            BuidarDades()
        End If

    End Sub

    Private Sub BuidarDades()

        txtDetall.Text = ""
        txtUsuariBaixa.Text = ""
        txtUsuariAlta.Text = usuariAct.Login
        cboTipus.ItemsSource = ""
        cboTipus.IsEditable = True

    End Sub

    Private Sub CarregaDades()

        _carregant = True

        With _tipus
            .Buscar(_codTipus)
            txtDetall.Text = .Detall
            dataAlta.SelectedDate = .Data_Alta

            If DateTime.Compare(.Data_Baixa, DateTime.MinValue) <> 0 Then
                dataBaixa.SelectedDate = .Data_Baixa
            End If

            'Carreguem la dada del tipus al combo
            cboTipus.Items.Add(.Tipus)
            cboTipus.SelectedIndex = cboTipus.Items.Count - 1

            'Busquem l'usuari que té per codi l'emmagatzemat al camp usuari_alta de la taula
            _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.codUsuari=" & .Usuari_Alta)
            txtUsuariAlta.Text = _dtUsuari.Rows(0)(5)

            'Fem el mateix per a l'usuari que ho ha donat de baixa
            If .Usuari_Baixa <> "" Then
                _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.codUsuari=" & .Usuari_Baixa)
                txtUsuariBaixa.Text = _dtUsuari.Rows(0)(5)
            Else
                txtUsuariBaixa.Text = ""
            End If


        End With

        'Comprovem si al carregar les dades, l'usuari ja està donat de baixa
        If IsNothing(dataBaixa.SelectedDate) Then
            _era_baixa = True
        ElseIf DateTime.Compare(dataBaixa.SelectedDate, DateTime.MinValue) = 0 Then
            _era_baixa = True
        Else
            _era_baixa = False
        End If

        _carregant = False

    End Sub

    Private Sub btnGuardar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnGuardar.Click

        If ComprovarDades() Then

            With _tipus
                .codTipus = _codTipus
                .Detall = txtDetall.Text.Trim
                .Data_Alta = dataAlta.SelectedDate
                .Data_Baixa = IIf(IsNothing(dataBaixa.SelectedDate), DateTime.MinValue, dataBaixa.SelectedDate)
                .Usuari_Baixa = txtUsuariBaixa.Text.Trim
                .Tipus = cboTipus.Text

                'Busquem l'usuari que té per login l'emmagatzemat al camp txtUsuariAlta de la finestra
                _dtUsuari = _usuari.ObtenirUsuaris("Usuaris.login='" & txtUsuariAlta.Text.Trim & "' ")
                .Usuari_Alta = _dtUsuari.Rows(0)(0)

                Try
                    .Gravar()
                Catch ex As Exception
                    MessageBox.Show _
                    (ex.Message, "Error al guardar", MessageBoxButton.OK, MessageBoxImage.Error)
                End Try

            End With
            Close()

        End If

    End Sub

    Private Function ComprovarDades() As Boolean

        Try
            ComprovarCombo(cboTipus.Text, "el tipus de sistema")
            Comprovar(txtDetall, "el detall")


            ComprovarTipusExistent()

        Catch ex As Exception
            MessageBox.Show _
              (ex.Message, "Tipus", MessageBoxButton.OK, MessageBoxImage.Information)

            Return False
        End Try

        Return True

    End Function

    Private Sub Comprovar(ByRef oControl As TextBox, _
                                  ByVal sNomDada As String)

        If oControl.Text = "" Then
            oControl.Focus()
            Throw New Exception("Ha d'introduir " & sNomDada & ".")
        End If
    End Sub

    Private Sub ComprovarCombo(ByRef sValor As String, _
                               ByVal sNomDada As String)

        If sValor = "" Then
            Throw New Exception("Ha d'introduir " & sNomDada & ".")
        End If
    End Sub

    Private Sub ComprovarTipusExistent()
        If _tipus.DadaExistent("tipus", "'" & cboTipus.Text & "'") Then
            cboTipus.Focus()
            Throw New Exception("Ja existeix un tipus de sistema a la base de dades amb aquest nom.")
        End If
    End Sub

    Private Sub btnSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnSortir.Click

        Me.Close()

    End Sub

End Class
