﻿Imports System.Data

Public Class GestioIncidencies

    Private ReadOnly _incidencia As Incidencies = New Incidencies

    Private _dtIncidencia As DataTable
    Private _filtre As String
    Private _filtreGestor As String
    Private _filtreTecnic As String
    Private _filtreEstat As String

    Private _codIncSelect As Integer
    Private _dadesfila As DataRowView
    Private _dadescomboUsuaris As DataRowView

    Private Sub CarregarPantalla(sender As Object, e As EventArgs) Handles Me.Loaded

        InitializeComponent()

        CarregarComboUsuaris()

    End Sub

    Private Sub btnSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnSortir.Click
        Me.Close()
    End Sub

    'Carrega les dades al grid
    Private Sub btnBuscar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnBuscar.Click
        CarregarGrid()
        NetejarFiltres()
    End Sub

    'Carrega al grid el llistat de sistemes
    Private Sub CarregarGrid()

        CarregarFiltre()

        _dtIncidencia = _incidencia.ObtenirIncidencies(_filtre, _filtreGestor, _filtreTecnic)
        Me.grdIncidencies.ItemsSource = _dtIncidencia.DefaultView

    End Sub

    'Neteja els filtres de la pantalla
    Private Sub NetejarFiltres()

        cboTecnic.ClearValue(ComboBox.SelectedItemProperty)
        cboOficinista.ClearValue(ComboBox.SelectedItemProperty)
        dataCancel.ClearValue(DatePicker.SelectedDateProperty)
        dataObertura.ClearValue(DatePicker.SelectedDateProperty)
        chkCancel.IsChecked = False
        chkPendent.IsChecked = False
        chkTancada.IsChecked = False

    End Sub

    'Genera el filtre per a la búsqueda de dades
    Private Sub CarregarFiltre()

        _filtre = ""
        _filtreGestor = ""
        _filtreTecnic = ""

        'Data Alta
        If Not IsNothing(dataObertura.SelectedDate) Then
            If DateTime.Compare(dataObertura.SelectedDate, DateTime.MinValue) <> 0 Then
                If _filtre = "" Then
                    _filtre = " i.data_obertura ='" & dataObertura.SelectedDate & "' "
                Else
                    _filtre = _filtre & " and s.data_obertura = '" & dataObertura.SelectedDate & "' "
                End If
            End If
        End If

        'Data Baixa
        If Not IsNothing(dataCancel.SelectedDate) Then
            If DateTime.Compare(dataCancel.SelectedDate, DateTime.MinValue) <> 0 Then
                If _filtre = "" Then
                    _filtre = " s.data_baixa = '" & dataCancel.SelectedDate & "' "
                Else
                    _filtre = _filtre & " and s.data_baixa = '" & dataCancel.SelectedDate & "' "
                End If
            End If
        End If

        'Combo de Gestors
        If Not IsNothing(cboOficinista.SelectedItem) Then
            'Agafem les dades del combo. Sabem que es porta aquestes dades:
            '0-codUsuari, 1-login
            _dadescomboUsuaris = cboOficinista.SelectedItem
            _filtreGestor = " i.codGestor ='" & _dadescomboUsuaris(0) & "' "
        End If

        'Combo de Técnics
        If Not IsNothing(cboTecnic.SelectedItem) Then
            'Agafem les dades del combo. Sabem que es porta aquestes dades:
            '0-codUsuari, 1-login
            _dadescomboUsuaris = cboTecnic.SelectedItem
            _filtreTecnic = " i.codTecnic ='" & _dadescomboUsuaris(0) & "' "
        End If

        'filtre d'estats
        _filtreEstat = ""

        'Pendent
        If chkPendent.IsChecked Then
            AfegirEstatFiltre(INC_ESTAT_PEND)
        End If

        'Ofic
        If chkCancel.IsChecked Then
            AfegirEstatFiltre(INC_ESTAT_CANC)
        End If

        'Tec
        If chkTancada.IsChecked Then
            AfegirEstatFiltre(INC_ESTAT_TANC)
        End If

        If _filtre <> "" Then
            If _filtreEstat <> "" Then
                _filtre = _filtre & " and (" & _filtreEstat & ")"
            End If
        Else
            _filtre = _filtreEstat
        End If


    End Sub

    'S'afegeix/en al filtre el/s estat/s sel·leccionat/s
    Private Sub AfegirEstatFiltre(ByVal sPerfil As String)

        If _filtreEstat = "" Then
            _filtreEstat = "i.estat='" & sPerfil & "'"
        Else
            _filtreEstat = _filtreEstat & " or i.estat='" & sPerfil & "'"
        End If
    End Sub

    Private Sub CarregarComboUsuaris()

        Dim oUsuaris As New Usuaris

        _filtreGestor = "up.codPerfil=" & ID_OFI & " "
        _filtreTecnic = "up.codPerfil=" & ID_TEC & " "

        'Carreguem els combos amb les dades de la taula Usuaris
        cboOficinista.ItemsSource = oUsuaris.ObtenirUsuariCbo(_filtreGestor).DefaultView
        cboOficinista.DisplayMemberPath = "login"
        cboOficinista.SelectedValuePath = "codUsuari"

        cboTecnic.ItemsSource = oUsuaris.ObtenirUsuariCbo(_filtreTecnic).DefaultView
        cboTecnic.DisplayMemberPath = "login"
        cboTecnic.SelectedValuePath = "codUsuari"

    End Sub


    'Guardem el codi del Sistema sel·lecionat al grid
    Private Sub grdIncidencies_SelectionChanged(sender As Object, e As System.EventArgs) _
    Handles grdIncidencies.SelectionChanged

        _dadesfila = Nothing

        'Comprovem que està sel·leccionada alguna fila abans d'assignar els seus valors a la variable
        If grdIncidencies.SelectedItems.Count <> 0 Then
            _dadesfila = grdIncidencies.SelectedItems(0)
        End If

        'Com veiem a la finestra, ens traiem les dades al grid en columnes de la següent manera:
        '0-codIncidencia, 1-gestor, 2-tecnic, 3-sistema, 4-adreça, 5-estat

        If Not IsNothing(_dadesfila) Then
            _codIncSelect = _dadesfila(0)
        Else
            _codIncSelect = 0
        End If

    End Sub

    'Obre la fitxa d'Incidencies per a crear-ne una de nova
    Private Sub btnAfegir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnAfegir.Click

        Dim _fitxaIncidencia As FitxaIncidencia = New FitxaIncidencia

        _codIncSelect = 0

        _fitxaIncidencia.Owner = Me
        _fitxaIncidencia.Carregar(_codIncSelect)

        'A l'afegir la nova Incdència, actualitzem les dades al grid, si prèviament havíem fet alguna cerca
        If grdIncidencies.Items.Count > 0 Then
            CarregarGrid()
        End If

    End Sub

    'Obre la pantalla d'Incidències per a modificar la què s'ha sel·leccionat al grid
    Private Sub btnModificar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnModificar.Click

        If _codIncSelect <> 0 Then

            Dim _fitxaIncidencia As FitxaIncidencia = New FitxaIncidencia

            _fitxaIncidencia.Owner = Me
            _fitxaIncidencia.Carregar(_codIncSelect)
            CarregarGrid()
        Else
            MessageBox.Show _
              ("Ha de sel·leccionar una incidència", "Modificar Incidència", _
               MessageBoxButton.OK, MessageBoxImage.Exclamation)

        End If

    End Sub

    Private Sub btnCancel_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnCancel.Click

        Dim incidencies As Incidencies = New Incidencies

        Dim iRes As Integer

        If _codIncSelect <> 0 Then
            'Comprovem si l'estat de la incidència és cancel·lat
            'Sabem que a la finestra, ens traiem les dades al grid en columnes de la següent manera:
            '0-codIncidencia, 1-codGestor, 2-codTecnic, 3-sistema, 4-adreça, 5-cp, 6-estat, 
            '7-data_obertura, 8-data_tancament, 9-data_cancel
            If _dadesfila(6) = INC_ESTAT_PEND Then

                iRes = MessageBox.Show _
                        ("¿Està segur que desitja cancel·lar la incidència ?", "Cancel·lar Incidència", _
                        MessageBoxButton.YesNo, MessageBoxImage.Question)

                If iRes = vbYes Then
                    Try
                        _incidencia.CanviarEstat(_codIncSelect, INC_ESTAT_CANC)
                    Catch ex As Exception
                        MessageBox.Show _
                        (ex.Message, "Error al cancel·lar", MessageBoxButton.OK, MessageBoxImage.Error)
                    End Try

                    CarregarGrid()

                End If
            ElseIf _dadesfila(6) = INC_ESTAT_TANC Then
                MessageBox.Show _
                    ("No es pot cancel·lar una incidència resolta", "Error al cancel·lar", _
                     MessageBoxButton.OK, MessageBoxImage.Error)
            Else
                MessageBox.Show _
                     ("La incidència ja està cancel·lada", "Cancel·lar Incidència", _
                      MessageBoxButton.OK, MessageBoxImage.Exclamation)
            End If
        Else

            MessageBox.Show _
              ("Ha de sel·leccionar alguna incidència", "Cancel·lar Incidència", _
               MessageBoxButton.OK, MessageBoxImage.Exclamation)
        End If

    End Sub
End Class
