﻿Imports System.Data.SqlClient
Imports System.Data

Public Class GestorSql

    Private ReadOnly _connexio As New Connexio
    Private _sqlAd As New SqlDataAdapter
    Private _sqlCommand As SqlCommand
    Private _dtSet As DataSet

    Private _select As String

    Public Function ExecutarSql(ByVal sTaula As String, _
                                      ByVal sCamps As String, _
                                      Optional ByVal sFiltre As String = "",
                                      Optional ByVal sOrdre As String = "") As DataSet

        Try
            _connexio.ObrirConnexio()

            _select = "Select " & sCamps & " from " & sTaula
            If sFiltre <> "" Then
                _select = _select & " Where " & sFiltre
            End If

            If sOrdre <> "" Then
                _select = _select & " Order by " & sOrdre
            End If

            _sqlAd = New SqlDataAdapter(_select, _connexio.ConnexioActiva)

            _dtSet = New DataSet
            _sqlAd.Fill(_dtSet)

            _connexio.TancarConnexio()

            Return _dtSet

        Catch e As Exception
            _connexio.TancarConnexio()
            Throw New Exception(e.Message)
        End Try

    End Function

    Public Function ExecutarSql(ByVal sSelect As String) As DataSet

        Try
            _connexio.ObrirConnexio()

            _sqlAd = New SqlDataAdapter(sSelect, _connexio.ConnexioActiva)

            _dtSet = New DataSet
            _sqlAd.Fill(_dtSet)

            _connexio.TancarConnexio()

            Return _dtSet
        Catch e As Exception
            _connexio.TancarConnexio()
            Throw New Exception(e.Message)
        End Try
    End Function

    Public Sub Modificar(ByVal sTaula As String, _
               ByVal sValors As String, _
               Optional ByVal sFiltre As String = "")

        Try
            _connexio.ObrirConnexio()

            If sFiltre <> "" Then
                sFiltre = " Where " & sFiltre
            End If

            _sqlCommand = _
              New SqlCommand("Update " & sTaula & " set " & sValors & sFiltre, _connexio.ConnexioActiva)
            _sqlCommand.ExecuteNonQuery()

            _connexio.TancarConnexio()
        Catch
            _connexio.TancarConnexio()
            Throw New Exception("Error al guardar les mofificacions")
        End Try
    End Sub

    Public Sub Afegir(ByVal sTaula As String, _
                      ByVal sCamps As String, _
                      ByVal sValors As String)

        Try
            _connexio.ObrirConnexio()

            _sqlCommand = _
              New SqlCommand("Insert into " & sTaula & "(" & sCamps & ")" & _
                             " values (" & sValors & ")", _connexio.ConnexioActiva)
            _sqlCommand.ExecuteNonQuery()

            _connexio.TancarConnexio()
        Catch
            _connexio.TancarConnexio()
            Throw New Exception("Error al guardar les modificacions")
        End Try
    End Sub

    'Afegeix un registre i retorna l'identificador
    Public Function AfegirId(ByVal staula As String, _
                    ByVal scamps As String, _
                    ByVal svalors As String) As Integer

        Dim cod As Integer

        Try
            _connexio.ObrirConnexio()

            _sqlCommand = _
              New SqlCommand("insert into " & staula & "(" & scamps & ")" & _
                             " values (" & svalors & ") " & _
                             "select scope_identity()", _connexio.ConnexioActiva)

            cod = _sqlCommand.ExecuteScalar()

            _connexio.TancarConnexio()

            Return cod

        Catch
            _connexio.TancarConnexio()
            Throw New Exception("Error al guardar les dades")
        End Try

    End Function

    Public Sub Esborrar(ByVal sTaula As String, _
                      ByVal sFiltre As String)

        Try
            _connexio.ObrirConnexio()

            If sFiltre <> "" Then
                sFiltre = " Where " & sFiltre
            End If

            _sqlCommand = _
              New SqlCommand("Delete " & sTaula & sFiltre, _connexio.ConnexioActiva)
            _sqlCommand.ExecuteNonQuery()

            _connexio.TancarConnexio()

        Catch
            _connexio.TancarConnexio()
            Throw New Exception("Error a l'intentar esborrar les dades")
        End Try
    End Sub

End Class
