﻿Imports System.Data

Public Class Incidencies

    Private ReadOnly _gestSql As New GestorSql()
    Private _dtInc As New DataTable

    Private _codIncidencia As Long
    Private _codGestor As Integer
    Private _codTecnic As Integer
    Private _codSistema As Integer
    Private _adreça As String
    Private _cp As String
    Private _estat As String
    Private _data_obertura As Date
    Private _data_tancament As Date
    Private _data_cancel As Date
    Private _observacions_cancel As String
    Private _usuari_cancel As String
    Private _usuari_tancament As String


    Private _select As String
    Private _taula As String
    Private _camps As String
    Private _valors As String
    Private _campsValors As String
    Private _filtre As String
    Private _ordre As String


    Public Property codIncidencia() As Long
        Get
            Return _codIncidencia
        End Get
        Set(ByVal value As Long)
            _codIncidencia = value
        End Set
    End Property

    Public Property codGestor() As Integer
        Get
            Return _codGestor
        End Get
        Set(ByVal value As Integer)
            _codGestor = value
        End Set
    End Property

    Public Property codTecnic() As Integer
        Get
            Return _codTecnic
        End Get
        Set(ByVal value As Integer)
            _codTecnic = value
        End Set
    End Property

    Public Property Adreça() As String
        Get
            Return _adreça
        End Get
        Set(ByVal value As String)
            _adreça = value
        End Set
    End Property

    Public Property cp() As String
        Get
            Return _cp
        End Get
        Set(ByVal value As String)
            _cp = value
        End Set
    End Property

    Public Property codSistema() As String
        Get
            Return _codSistema
        End Get
        Set(ByVal value As String)
            _codSistema = value
        End Set
    End Property

    Public Property Estat() As String
        Get
            Return _estat
        End Get
        Set(ByVal value As String)
            _estat = value
        End Set
    End Property

    Public Property data_Alta() As Date
        Get
            Return _data_obertura
        End Get
        Set(ByVal value As Date)
            _data_obertura = value
        End Set
    End Property

    Public Property data_Tancament() As Date
        Get
            Return _data_tancament
        End Get
        Set(ByVal value As Date)
            _data_tancament = value
        End Set
    End Property

    Public Property data_Cancel() As Date
        Get
            Return _data_cancel
        End Get
        Set(ByVal value As Date)
            _data_cancel = value
        End Set
    End Property

    Public Property Obs_Cancel() As String
        Get
            Return _observacions_cancel
        End Get
        Set(ByVal value As String)
            _observacions_cancel = value
        End Set
    End Property

    Public Property usuari_Cancel() As String
        Get
            Return _usuari_cancel
        End Get
        Set(ByVal value As String)
            _usuari_cancel = value
        End Set
    End Property

    Public Property usuari_Tancament() As String
        Get
            Return _usuari_tancament
        End Get
        Set(ByVal value As String)
            _usuari_tancament = value
        End Set
    End Property

    'Retorna un datatable per a carregar el grid d'Incidències
    Public Function ObtenirIncidencies(Optional ByVal sFiltreInc As String = "", _
                                  Optional ByVal sFiltreGest As String = "", _
                                  Optional ByVal sFiltreTec As String = "") As DataTable

        _filtre = ""
        If sFiltreInc <> "" Then
            _filtre = " and " & sFiltreInc
        End If

        If sFiltreGest <> "" Then
            If _filtre = "" Then
                _filtre = " and " & sFiltreGest
            End If
        End If

        If sFiltreTec <> "" Then
            If _filtre = "" Then
                _filtre = " and " & sFiltreTec
            End If
        End If

        _select = "SELECT i.codIncidencia,  u.login As gestor, us.login as tecnic, s.sistema, i.adreça, i.cp, " & _
                 "i.estat, i.data_obertura, i.data_tancament, i.data_cancel " & _
                  "FROM Usuaris u INNER JOIN " & _
                  "Incidencies i ON u.codUsuari = i.codGestor INNER JOIN " & _
                  "Usuaris us ON us.codUsuari = i.codTecnic INNER JOIN " & _
                  "SistemesEnllumenat s ON i.codSistema = s.codSistema " & _
                   _filtre & " " & _
                  "ORDER BY i.data_obertura DESC "

        _dtInc = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtInc

    End Function

    'Carrega una incidència pel seu codi
    Public Sub Buscar(ByVal lidInc As Long)

        _taula = "Incidencies"
        _camps = "*"
        _filtre = "codIncidencia=" & lidInc

        _dtInc = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        'Comprovem si hi ha registres
        If _dtInc.Rows.Count > 0 Then
            Carregar()
        Else
            BuidarDades()
        End If

    End Sub

    'Ens retorna els valors de codis d'incidències carregades al sistema
    Public Function ObtenirIncCbo(Optional ByVal sFiltre As String = "") As DataTable

        If sFiltre <> "" Then
            sFiltre = "Where " & sFiltre
        End If

        _select = "SELECT codIncidencia, codGestor, codTecnic" & _
                  "FROM Incidencies " & sFiltre & " " & _
                  "ORDER BY codIncidencia "

        _dtInc = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtInc

    End Function

    'Carrego les dades de la taula a les propietats de la classe
    Private Sub Carregar()

        With _dtInc.Rows(0)
            _codIncidencia = .Item("codIncidencia")
            _codGestor = .Item("codGestor")
            _codTecnic = .Item("codTecnic")
            _codSistema = .Item("codSistema")
            _adreça = .Item("adreça")
            _cp = .Item("cp")
            _estat = .Item("estat")
            _data_obertura = .Item("data_obertura")
            _data_tancament = IIf(IsDBNull(.Item("data_tancament")), DateTime.MinValue, .Item("data_tancament"))
            _data_cancel = IIf(IsDBNull(.Item("data_cancel")), DateTime.MinValue, .Item("data_cancel"))
            _observacions_cancel = IIf(IsDBNull(.Item("observacions_cancel")), "", .Item("observacions_cancel"))
            _usuari_cancel = IIf(IsDBNull(.Item("usuari_cancel")), "", .Item("usuari_cancel"))
            _usuari_tancament = IIf(IsDBNull(.Item("usuari_tancament")), "", .Item("usuari_tancament"))

        End With

    End Sub

    'Vacio los datos de las propiedades de la clase
    Private Sub BuidarDades()
        _codIncidencia = 0
        _codGestor = 0
        _codTecnic = 0
        _codSistema = 0
        _adreça = ""
        _cp = ""
        _estat = ""
        _data_obertura = DATA_NULL
        _data_tancament = DATA_NULL
        _data_cancel = DATA_NULL
        _observacions_cancel = ""
        _usuari_cancel = ""
        _usuari_tancament = ""

    End Sub

    'Gravem les dades de la incidència.
    'Si l'identificador és '0' es tractarà d'una alta
    'Si l'identificador és diferent de '0' es tractarà d'una modificació
    Public Sub Gravar()

        _taula = "Incidencies"

        'Alta
        If _codIncidencia = 0 Then

            _camps = "codGestor,codTecnic,codSistema,adreça,cp,estat,data_obertura," & _
                "data_tancament,data_cancel,observacions_cancel,usuari_cancel,usuari_tancament "

            _valors = _
              _codGestor & "," & _codTecnic & "," & _codSistema & ",'" & _adreça & _
              "','" & _cp & "','" & _estat & "','" & _data_obertura & "',Null,Null,Null,Null,Null"

            _codIncidencia = _gestSql.AfegirId(_taula, _camps, _valors)
        Else
            'Modificació 
            _filtre = "codIncidencia=" & _codIncidencia

            _campsValors = "codGestor=" & _codGestor & ", codTecnic=" & _codTecnic & ", " & _
                "codSistema=" & _codSistema & ", adreça='" & _adreça & "', " & _
                "cp='" & _cp & "', estat='" & _estat & "', data_obertura='" & _data_obertura & _
                "', data_tancament='" & IIf(DateTime.Compare(_data_tancament, DateTime.MinValue) = 0, _
                                                         "", _data_tancament) & _
                "', data_cancel='" & IIf(DateTime.Compare(_data_cancel, DateTime.MinValue) = 0, _
                                                         "", _data_cancel) & _
                "', observacions_cancel='" & _observacions_cancel & "', usuari_cancel='" & _
               _usuari_cancel & "', usuari_tancament='" & _usuari_tancament & "' "

            _gestSql.Modificar(_taula, _campsValors, _filtre)

        End If

    End Sub

    'Retorna si hi ha alguna dada associada a la incidència
    'Si és així no es podrà cancel·lar
    'Ex: usuaris o sistemes associats a incidències obertes no es podran donar de baixa
    Public Function AssociadaIncidencia(ByVal sNomIdCamp As String, _
                            ByVal idValorCamp As Integer) As Boolean

        Dim dtIncidencies As New DataTable()
        _taula = "Incidencies"
        _camps = sNomIdCamp
        _filtre = sNomIdCamp & "=" & idValorCamp & "and estat='" & INC_ESTAT_PEND & "' "

        dtIncidencies = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        If dtIncidencies.Rows.Count > 0 Then
            Return True
        Else
            Return False
        End If

        dtIncidencies = Nothing

    End Function

    'Canvia d'estat una incidència
    Public Sub CanviarEstat(ByVal lIdInc As Long, _
                             ByVal sNouEstat As String)

        _taula = "Incidencies"
        _filtre = "codIncidencia=" & lIdInc
        Select Case sNouEstat

            Case INC_ESTAT_CANC
                _camps = "estat='" & INC_ESTAT_CANC & "'," & _
                  "data_cancel='" & Date.Today & "', usuari_cancel='" & usuariAct.Login & "', " & _
                  "observacions_cancel='Incidència cancel·lada per un gestor/administrador' "

            Case INC_ESTAT_PEND
                _camps = "estat='" & INC_ESTAT_PEND & "'," & _
                  "data_cancel=NULL, usuari_cancel=NULL, observacions_cancel=NULL "

        End Select

        _gestSql.Modificar(_taula, _camps, _filtre)

    End Sub

    Public Function EsBaixa() As Boolean

        Dim dtTemp As DataTable

        _taula = "Incidencies"
        _camps = "data_cancel"
        _filtre = "codIncidencia=" & _codIncidencia

        dtTemp = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        'Comprovem la data de baixa
        If dtTemp.Rows(0)(0).ToString <> "" Then
            Return True
        Else
            Return False
        End If

    End Function

End Class
