﻿Imports System.Data

Public Class MantenimentSistemesEnllumenat

    Private ReadOnly _sistema As SistemesEnllumenat = New SistemesEnllumenat

    Private _dtSistema As DataTable
    Private _filtre As String
    Private _filtreTipus As String

    Private _codSistSelect As Integer
    Private _sistemes As String
    Private _dadesfila As DataRowView
    Private _dadescomboSistema As DataRowView
    Private _dadescomboTipus As DataRowView

    Private Sub CarregarPantalla(sender As Object, e As EventArgs) Handles Me.Loaded

        If usuariAct.TePerfil(OFI) Then
            btnAfegir.IsEnabled = False
            btnModificar.IsEnabled = False
            btnEsborrar.IsEnabled = False
        End If

        InitializeComponent()

        'CarregarGrid()
        CarregarComboTipus()
        CarregarComboSistema()

    End Sub

    Private Sub btnSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnSortir.Click
        Me.Close()
    End Sub

    'Carrega les dades al grid
    Private Sub btnBuscar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnBuscar.Click
        CarregarGrid()
        NetejarFiltres()
    End Sub

    'Carrega al grid el llistat de sistemes
    Private Sub CarregarGrid()

        CarregarFiltre()

        _dtSistema = _sistema.ObtenirSistema(_filtre, _filtreTipus)

        'Canvia la data de baixa a "" si és nul·la. En aquest cas, a la grid, el camp de "data_baixa" és a la columna 4 i "usuari_baixa" és la 5
        CanviarDataBaixa(_dtSistema, 4, 5)

        Me.grdSistemes.ItemsSource = _dtSistema.DefaultView

    End Sub

    'Neteja els filtres de la pantalla
    Private Sub NetejarFiltres()

        cboTipus.ClearValue(ComboBox.SelectedItemProperty)
        cboSistema.ClearValue(ComboBox.SelectedItemProperty)
        dataAlta.ClearValue(DatePicker.SelectedDateProperty)
        dataBaixa.ClearValue(DatePicker.SelectedDateProperty)

    End Sub

    'Genera el filtre per a la búsqueda de dades
    Private Sub CarregarFiltre()

        _filtre = ""
        _filtreTipus = ""

        'Data Alta
        If Not IsNothing(dataAlta.SelectedDate) Then
            If DateTime.Compare(dataAlta.SelectedDate, DateTime.MinValue) <> 0 Then
                If _filtre = "" Then
                    _filtre = " s.data_alta ='" & dataAlta.SelectedDate & "' "
                Else
                    _filtre = _filtre & " and s.data_alta = '" & dataAlta.SelectedDate & "' "
                End If
            End If
        End If

        'Data Baixa

        If Not IsNothing(dataBaixa.SelectedDate) Then
            If DateTime.Compare(dataBaixa.SelectedDate, DateTime.MinValue) <> 0 Then
                If _filtre = "" Then
                    _filtre = " s.data_baixa = '" & dataBaixa.SelectedDate & "' "
                Else
                    _filtre = _filtre & " and s.data_baixa = '" & dataBaixa.SelectedDate & "' "
                End If
            End If
        End If

        'Combo de Tipus de Sistemes
        If Not IsNothing(cboTipus.SelectedItem) Then
            'Agafem les dades del combo. Sabem que es porta aquestes dades:
            '0-codTipus, 1-tipus
            _dadescomboTipus = cboTipus.SelectedItem
            _filtreTipus = " t.tipus ='" & _dadescomboTipus(1) & "' "
        End If

        'Combo de Sistemes
        If Not IsNothing(cboSistema.SelectedItem) Then
            'Agafem les dades del combo. Sabem que es porta aquestes dades:
            '0-codSistema, 1-sistema
            _dadescomboSistema = cboSistema.SelectedItem

            If _filtre = "" Then
                _filtre = " s.sistema ='" & _dadescomboSistema(1) & "' "
            Else
                _filtre = _filtre & " and s.sistema = '" & _dadescomboSistema(1) & "' "
            End If
        End If

    End Sub

    Private Sub CarregarComboTipus()

        Dim oTipus As New SistemesEnllumenat

        'Carreguem el combo amb les dades de la taula SistemesEnllumenat
        cboTipus.ItemsSource = oTipus.ObtenirTipusCbo.DefaultView
        cboTipus.DisplayMemberPath = "tipus"
        cboTipus.SelectedValuePath = "codTipus"

    End Sub

    Private Sub CarregarComboSistema()

        Dim oSistema As New SistemesEnllumenat

        'Carreguem el combo amb les dades de la taula TipusSistema
        cboSistema.ItemsSource = oSistema.ObtenirSistemaCbo.DefaultView
        cboSistema.DisplayMemberPath = "sistema"
        cboSistema.SelectedValuePath = "codSistema"

    End Sub


    'Guardem el codi del Sistema sel·lecionat al grid
    Private Sub grdSistemes_SelectionChanged(sender As Object, e As System.EventArgs) _
    Handles grdSistemes.SelectionChanged

        _dadesfila = Nothing

        'Comprovem que està sel·leccionada alguna fila abans d'assignar els seus valors a la variable
        If grdSistemes.SelectedItems.Count <> 0 Then
            _dadesfila = grdSistemes.SelectedItems(0)
        End If

        'Com veiem a la finestra, ens traiem les dades al grid en columnes de la següent manera:
        '0-codSistema, 1-sistema, 2-tipus, 3-data_alta, 4-data_baixa

        If Not IsNothing(_dadesfila) Then
            _codSistSelect = _dadesfila(0)
            _sistemes = _dadesfila(1)
        Else
            _codSistSelect = 0
            _sistemes = ""
        End If

    End Sub

    'Obre la fitxa de Sistema per a crear-ne un de nou
    Private Sub btnAfegir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnAfegir.Click

        Dim _fitxaSistema As FitxaSistema = New FitxaSistema

        _codSistSelect = 0

        _fitxaSistema.Owner = Me
        _fitxaSistema.Carregar(_codSistSelect)

        'A l'afegir el nou Tipus, actualitzem les dades al grid, si prèviament havíem fet alguna cerca
        If grdSistemes.Items.Count > 0 Then
            CarregarGrid()
        End If

    End Sub

    'Obre la pantalla de Sistemes per a modificar el que s'ha sel·leccionat al grid
    Private Sub btnModificar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnModificar.Click

        If _codSistSelect <> 0 Then

            Dim _fitxaSistema As FitxaSistema = New FitxaSistema

            _fitxaSistema.Owner = Me
            _fitxaSistema.Carregar(_codSistSelect)
            CarregarGrid()
        Else
            MessageBox.Show _
              ("Ha de sel·leccionar un sistema", "Modificar Sistema", MessageBoxButton.OK, MessageBoxImage.Exclamation)

        End If

    End Sub

    Private Sub btnEsborrar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnEsborrar.Click

        Dim incidencies As Incidencies = New Incidencies

        Dim iRes As Integer

        If _codSistSelect <> 0 Then
            'Comprovem si el camp "data_baixa" està buit o no
            If _dadesfila(4).ToString = "" Then
                If Not incidencies.AssociadaIncidencia("codSistema", _codSistSelect) Then

                    iRes = MessageBox.Show _
                            ("¿Està segur que desitja eliminar el Sistema " & _
                             _sistemes & "?", "Baixa Sistema", _
                            MessageBoxButton.YesNo, MessageBoxImage.Question)

                    If iRes = vbYes Then
                        Try
                            _sistema.Esborrar(_codSistSelect)
                        Catch ex As Exception
                            MessageBox.Show _
                            (ex.Message, "Error a l'esborrar", MessageBoxButton.OK, MessageBoxImage.Error)
                        End Try

                        'CarregarGrid()
                    End If

                Else
                    MessageBox.Show _
                      ("No es pot esborrar el sistema perquè està associat a alguna incidència oberta.", _
                       "Baixa Sistema", MessageBoxButton.OK, MessageBoxImage.Exclamation)

                End If

            Else
                MessageBox.Show _
                     ("El sistema ja està donat de baixa", "Baixa Sistema", _
                      MessageBoxButton.OK, MessageBoxImage.Exclamation)
            End If
        Else

            MessageBox.Show _
              ("Ha de sel·leccionar algun sistema", "Baixa Sistema", _
               MessageBoxButton.OK, MessageBoxImage.Exclamation)
        End If

    End Sub

End Class
