﻿Imports System.Data

Public Class MantenimentTipus

    Private ReadOnly _tipus As TipusSistema = New TipusSistema
   
    Private _dtTipus As DataTable
    Private _filtre As String

    Private _codTipuSelect As Integer
    Private _tipusdesistema As String
    Private _dadesfila As DataRowView
    Private _dadescombo As DataRowView

    Private Sub CarregarPantalla(sender As Object, e As EventArgs) Handles Me.Loaded

        If usuariAct.TePerfil(OFI) Then
            btnAfegir.IsEnabled = False
            btnModificar.IsEnabled = False
            btnEsborrar.IsEnabled = False
        End If

        InitializeComponent()

        'CarregarGrid()
        CarregarComboTipus()

    End Sub

    Private Sub btnSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnSortir.Click
        Me.Close()
    End Sub

    'Carrega les dades al grid
    Private Sub btnBuscar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnBuscar.Click
        CarregarGrid()
        NetejarFiltres()
    End Sub

    'Carrega al grid el llistat de tipus de sistemes 
    Private Sub CarregarGrid()

        CarregarFiltre()

        _dtTipus = _tipus.ObtenirTipus(_filtre)

        'Canvia la data de baixa a "" si és nul·la. En aquest cas, a la grid, el camp de "data_baixa" és a la columna 4 i "usuari_baixa" és la 5
        CanviarDataBaixa(_dtTipus, 4, 5)

        Me.grdTipus.ItemsSource = _dtTipus.DefaultView

    End Sub

    'Neteja els filtres de la pantalla
    Private Sub NetejarFiltres()

        cboTipus.ClearValue(ComboBox.SelectedItemProperty)
        dataAlta.ClearValue(DatePicker.SelectedDateProperty)
        dataBaixa.ClearValue(DatePicker.SelectedDateProperty)

    End Sub

    'Genera el filtre per a la búsqueda de dades
    Private Sub CarregarFiltre()

        _filtre = ""

        'Data Alta
        If Not IsNothing(dataAlta.SelectedDate) Then
            If DateTime.Compare(dataAlta.SelectedDate, DateTime.MinValue) <> 0 Then
                If _filtre = "" Then
                    _filtre = " TipusSistema.data_alta ='" & dataAlta.SelectedDate & "' "
                Else
                    _filtre = _filtre & " and TipusSistema.data_alta = '" & dataAlta.SelectedDate & "' "
                End If
            End If
        End If

        'Data Baixa

        If Not IsNothing(dataBaixa.SelectedDate) Then
            If DateTime.Compare(dataBaixa.SelectedDate, DateTime.MinValue) <> 0 Then
                If _filtre = "" Then
                    _filtre = " TipusSistema.data_baixa = '" & dataBaixa.SelectedDate & "' "
                Else
                    _filtre = _filtre & " and TipusSistema.data_baixa = '" & dataBaixa.SelectedDate & "' "
                End If
            End If
        End If


        'Combo de Tipus de Sistemes
        If Not IsNothing(cboTipus.SelectedItem) Then
            'Agafem les dades del combo. Sabem que es porta aquestes dades:
            '0-codTipus, 1-tipus
            _dadescombo = cboTipus.SelectedItem

            If _filtre = "" Then
                _filtre = " tipus ='" & _dadescombo(1) & "' "
            Else
                _filtre = _filtre & " and tipus = '" & _dadescombo(1) & "' "
            End If
        End If

    End Sub

    Private Sub CarregarComboTipus()

        Dim oTipus As New TipusSistema

        'Carreguem el combo amb les dades de la taula TipusSistema
        cboTipus.ItemsSource = oTipus.ObtenirTipusCbo.DefaultView
        cboTipus.DisplayMemberPath = "tipus"
        cboTipus.SelectedValuePath = "codTipus"

    End Sub


    'Guardem el codi del Tipus sel·lecionat al grid
    Private Sub grdTipus_SelectionChanged(sender As Object, e As System.EventArgs) _
    Handles grdTipus.SelectionChanged

        _dadesfila = Nothing

        'Comprovem que està sel·leccionada alguna fila abans d'assignar els seus valors a la variable
        If grdTipus.SelectedItems.Count <> 0 Then
            _dadesfila = grdTipus.SelectedItems(0)
        End If

        'Com veiem a la finestra, ens traiem les dades al grid en columnes de la següent manera:
        '0-codTipus, 1-tipus, 2-detall, 3-data_alta, 4-data_baixa

        If Not IsNothing(_dadesfila) Then
            _codTipuSelect = _dadesfila(0)
            _tipusdesistema = _dadesfila(1)
        Else
            _codTipuSelect = 0
            _tipusdesistema = ""
        End If

    End Sub

    'Obre la fitxa de Tipus per a crear-ne un de nou
    Private Sub btnAfegir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnAfegir.Click

        Dim _fitxaTipus As FitxaTipus = New FitxaTipus

        _codTipuSelect = 0

        _fitxaTipus.Owner = Me
        _fitxaTipus.Carregar(_codTipuSelect)

        'A l'afegir el nou Tipus, actualitzem les dades al grid, si prèviament havíem fet alguna cerca
        If grdTipus.Items.Count > 0 Then
            CarregarGrid()
        End If

    End Sub

    'Obre la pantalla de Tipus per a modificar el que s'ha sel·leccionat al grid
    Private Sub btnModificar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnModificar.Click

        If _codTipuSelect <> 0 Then

            Dim _fitxaTipus As FitxaTipus = New FitxaTipus

            _fitxaTipus.Owner = Me
            _fitxaTipus.Carregar(_codTipuSelect)
            CarregarGrid()
        Else
            MessageBox.Show _
              ("Ha de sel·leccionar un Tipus de sistema", "Modificar Tipus Sistema", MessageBoxButton.OK, MessageBoxImage.Exclamation)

        End If

    End Sub

    Private Sub btnEsborrar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnEsborrar.Click

        Dim sistemes As SistemesEnllumenat = New SistemesEnllumenat

        Dim iRes As Integer

        If _codTipuSelect <> 0 Then
            'Comprovem si el camp "data_baixa" està buit o no
            If _dadesfila(4).ToString = "" Then

                    iRes = MessageBox.Show _
                            ("¿Està segur que desitja eliminar el Tipus de sistema " & _
                             _tipusdesistema & "?", "Baixa Tipus Sistema", _
                            MessageBoxButton.YesNo, MessageBoxImage.Question)

                    If iRes = vbYes Then
                        Try
                            _tipus.Esborrar(_codTipuSelect)
                        Catch ex As Exception
                            MessageBox.Show _
                            (ex.Message, "Error a l'esborrar", MessageBoxButton.OK, MessageBoxImage.Error)
                        End Try

                        'CarregarGrid()
                    End If

            Else
                MessageBox.Show _
                     ("El tipus de sistema ja està donat de baixa", "Baixa Tipus Sistema", _
                      MessageBoxButton.OK, MessageBoxImage.Exclamation)
            End If
        Else

            MessageBox.Show _
              ("Ha de sel·leccionar algun tipus de sistema", "Baixa Tipus Sistema", _
               MessageBoxButton.OK, MessageBoxImage.Exclamation)
        End If

    End Sub

End Class
