﻿Imports System.Data

Public Class MantenimentUsuaris

    Private ReadOnly _usuaris As Usuaris = New Usuaris
    Private _fitxaUsuari As FitxaUsuari = New FitxaUsuari

    Private _dtUsuari As DataTable
    Private _filtre As String
    Private _filtrePerfils As String

    Private _codUsuSelect As Integer
    Private _nomcognomsUsuSelect As String
    Private _dadesfila As DataRowView


    Private Sub MantenimentUsuaris_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        If usuariAct.TePerfil(OFI) Then
            btnAfegir.IsEnabled = False
            btnModificar.IsEnabled = False
            btnBaixa.IsEnabled = False
        End If

        InitializeComponent()

    End Sub

    Private Sub btnSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnSortir.Click
        Me.Close()
    End Sub

    'Carrega les dades al grid
    Private Sub btnBuscar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnBuscar.Click
        CarregarGrid()
    End Sub

    'Carrega al grid el llistat d'usuaris 
    Private Sub CarregarGrid()

        CarregarFiltre()

        _dtUsuari = _usuaris.ObtenirUsuaris(_filtre)

        'Canvia la data de baixa a "" si és nul·la. En aquest cas, a la grid, el camp de "data_baixa" és a la columna 6 i "usuari_baixa" és la 7
        CanviarDataBaixa(_dtUsuari, 6, 7)

        Me.grdUsuaris.ItemsSource = _dtUsuari.DefaultView

    End Sub

    'Genera el filtre per a la búsqueda de dades
    Private Sub CarregarFiltre()

        _filtre = ""

        'Nom 
        If txtNom.Text <> "" Then
            _filtre = " Usuaris.nom like '%" & txtNom.Text.Trim & "%'"
        End If

        'Cognoms
        If txtCognoms.Text <> "" Then
            If _filtre = "" Then
                _filtre = " Usuaris.cognoms like '%" & txtCognoms.Text.Trim & "%'"
            Else
                _filtre = _filtre & " and Usuaris.cognoms like '%" & txtCognoms.Text.Trim & "%'"
            End If
        End If

        'DNI
        If txtDNI.Text <> "" Then
            If _filtre = "" Then
                _filtre = " Usuaris.dni like '%" & txtDNI.Text.Trim & "%'"
            Else
                _filtre = _filtre & " and Usuaris.dni like'%" & txtDNI.Text.Trim & "%'"
            End If
        End If

        _filtrePerfils = ""

        'Admin
        If chkAdministrador.IsChecked Then
            AfegirPerfilFiltre(ADM)
        End If

        'Ofic
        If chkOficinista.IsChecked Then
            AfegirPerfilFiltre(OFI)
        End If

        'Tec
        If chkTecnic.IsChecked Then
            AfegirPerfilFiltre(TEC)
        End If

        If _filtre <> "" Then
            If _filtrePerfils <> "" Then
                _filtre = _filtre & " and (" & _filtrePerfils & ")"
            End If
        Else
            _filtre = _filtrePerfils
        End If

    End Sub

    'S'afegeix/en al filtre el/s perfil/s sel·leccionat/s
    Private Sub AfegirPerfilFiltre(ByVal sPerfil As String)

        If _filtrePerfils = "" Then
            _filtrePerfils = "Perfils.perfil='" & sPerfil & "'"
        Else
            _filtrePerfils = _filtrePerfils & " or Perfils.perfil='" & sPerfil & "'"
        End If
    End Sub

    'Guardem l'identificador, el nom i cognoms de l'usuari sel·lecionat al grid
    Private Sub grdUsuaris_SelectionChanged(sender As Object, e As System.EventArgs) _
    Handles grdUsuaris.SelectionChanged

        _dadesfila = Nothing

        'Comprovem que està sel·leccionada alguna fila abans d'assignar els seus valors a la variable
        If grdUsuaris.SelectedItems.Count <> 0 Then
            _dadesfila = grdUsuaris.SelectedItems(0)
        End If

        'Com veiem a la finestra, ens traiem les dades al grid en columnes de la següent manera:
        '0-codUsuari, 1-nom, 2-cognoms, 3-dni, 4-tlf, 5-login, 6-data_baixa

        If Not IsNothing(_dadesfila) Then
            _codUsuSelect = _dadesfila(0)
            _nomcognomsUsuSelect = _dadesfila(1) & " " & _dadesfila(2)
        Else
            _codUsuSelect = 0
            _nomcognomsUsuSelect = ""
        End If

    End Sub

    'Obre la fitxa d'usuari per a crear-ne un de nou
    Private Sub btnAfegir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnAfegir.Click

        Dim _fitxaUsuari As FitxaUsuari = New FitxaUsuari

        _codUsuSelect = 0

        _fitxaUsuari.Owner = Me
        _fitxaUsuari.Carregar(_codUsuSelect)

        'A l'afegir el nou usuari, actualitzem les dades al grid, si prèviament havíem fet alguna cerca
        If grdUsuaris.Items.Count > 0 Then
            CarregarGrid()
        End If

    End Sub

    'Obre la pantalla d'usuari per a modificar el que s'ha sel·leccionat al grid
    Private Sub btnModificar_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnModificar.Click

        If _codUsuSelect <> 0 Then

            Dim _fitxaUsuari As FitxaUsuari = New FitxaUsuari

            _fitxaUsuari.Owner = Me
            _fitxaUsuari.Carregar(_codUsuSelect)
            CarregarGrid()
        Else
            MessageBox.Show _
              ("Ha de sel·leccionar un usuari", "Modificar Usuari", MessageBoxButton.OK, MessageBoxImage.Exclamation)

        End If

    End Sub

    Private Sub btnBaixa_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnBaixa.Click

        Dim incidencies As Incidencies = New Incidencies

        Dim iRes As Integer

        If _codUsuSelect <> 0 Then
            'Comprovem si el camp "data_baixa" està buit o no
            If _dadesfila(6).ToString = "" Then
                If Not incidencies.AssociadaIncidencia("codGestor", _codUsuSelect) And _
                   Not incidencies.AssociadaIncidencia("codTecnic", _codUsuSelect) Then

                    iRes = MessageBox.Show _
                            ("Està segur que desitja eliminar l'usuari " & _nomcognomsUsuSelect & "?", "Baixa Usuari", _
                            MessageBoxButton.YesNo, MessageBoxImage.Question)

                    If iRes = vbYes Then
                        Try
                            _usuaris.Esborrar(_codUsuSelect)
                        Catch ex As Exception
                            MessageBox.Show _
                            (ex.Message, "Error a l'esborrar", MessageBoxButton.OK, MessageBoxImage.Error)
                        End Try

                        'CarregarGrid()
                    End If

                Else
                    MessageBox.Show _
                      ("No es pot esborrar l'usuari perquè té associada alguna incidència", "Baixa Usuari", _
                       MessageBoxButton.OK, MessageBoxImage.Exclamation)

                End If

            Else
                MessageBox.Show _
                     ("L'usuari ja està donat de baixa", "Baixa Usuari", _
                      MessageBoxButton.OK, MessageBoxImage.Exclamation)
            End If
        Else

            MessageBox.Show _
              ("Ha de sel·leccionar un usuari", "Baixa Usuari", _
               MessageBoxButton.OK, MessageBoxImage.Exclamation)
        End If

    End Sub

End Class
