﻿Public Class PantallaPrincipal

    Private mantUsuaris As MantenimentUsuaris = New MantenimentUsuaris
    Private mantTipus As MantenimentTipus = New MantenimentTipus
    Private mantSistemes As MantenimentSistemesEnllumenat = New MantenimentSistemesEnllumenat
    Private gestioIncidencies As GestioIncidencies = New GestioIncidencies
    Private informes As PantallaInformes = New PantallaInformes
    Private informes2 As PantallaInformes = New PantallaInformes
    Private informes3 As PantallaInformes = New PantallaInformes
    Private aproposit As APropositDe = New APropositDe

    Private Sub PantallaPrincipal_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        'Mostrem l'usuari que ha entrar a l'aplicació a la part de sota de la pantalla
        LblLogin.Content = "Usuari Actiu: " & usuariAct.Login

        CarregaMenus()

    End Sub

    Private Sub CarregaMenus()

        'Comprovem si el perfil és Oficinista per a modificar el menú i la botonera
        If usuariAct.TePerfil(OFI) Then
            mnuManteniment.Header = "_Llistats"
            mnuManteniment.InputGestureText = "Alt+L"
            btnSistemes.ToolTip = "Llistat de Sistemes d'Enllumenat"
            btnTipus.ToolTip = "Llistat de Tipus de Sistemes d'Enllumenat"
            mnuMantUsuaris.Visibility = Windows.Visibility.Collapsed
            btnUsuaris.Visibility = Windows.Visibility.Collapsed
            mnuInformes.Visibility = Windows.Visibility.Collapsed
        End If

    End Sub

    Private Sub btnSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles btnSortir.Click
        Environment.Exit(0)
    End Sub

    Private Sub mnuMantSortir_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles mnuMantSortir.Click
        Environment.Exit(0)
    End Sub

    Private Sub PantallaPrincipal_SizeChanged(sender As Object, e As System.Windows.SizeChangedEventArgs) Handles Me.SizeChanged
        Menu1.Width = Grid1.ActualWidth
        ToolBar1.Width = Grid1.ActualWidth
    End Sub

    'Usuaris
    Private Sub PantallaUsuaris(ByVal sender As Object, ByVal e As EventArgs) _
    Handles mnuMantUsuaris.Click, btnUsuaris.Click

        'Si no s'ha obert la finestra, crea una nova instància. Si s'ha obert, segueix amb el procés i la mostra.
        If mantUsuaris.IsLoaded = False Then
            mantUsuaris = New MantenimentUsuaris
        End If

        mantUsuaris.Owner = Me
        mantUsuaris.Show()
        mantUsuaris.Focus()
        mantUsuaris.WindowState = Windows.WindowState.Normal

    End Sub

    'Tipus de Sistemes
    Private Sub PantallaTipus(ByVal sender As Object, ByVal e As EventArgs) _
    Handles mnuMantTipus.Click, btnTipus.Click


        'Si no s'ha obert la finestra, crea una nova instància. Si s'ha obert, segueix amb el procés i la mostra.
        If mantTipus.IsLoaded = False Then
            mantTipus = New MantenimentTipus
        End If

        mantTipus.Owner = Me
        mantTipus.Show()
        mantTipus.Focus()
        mantTipus.WindowState = Windows.WindowState.Normal

    End Sub

    'Sistemes d'Enllumenat
    Private Sub PantallaSistemes(ByVal sender As Object, ByVal e As EventArgs) _
    Handles mnuMantSistemes.Click, btnSistemes.Click

        'Si no s'ha obert la finestra, crea una nova instància. Si s'ha obert, segueix amb el procés i la mostra.
        If mantSistemes.IsLoaded = False Then
            mantSistemes = New MantenimentSistemesEnllumenat
        End If

        mantSistemes.Owner = Me
        mantSistemes.Show()
        mantSistemes.Focus()
        mantSistemes.WindowState = Windows.WindowState.Normal

    End Sub

    'Incidències
    Private Sub PantallaIncidencies(ByVal sender As Object, ByVal e As EventArgs) _
    Handles mnuIncidencies.Click, btnIncidencies.Click

        'Si no s'ha obert la finestra, crea una nova instància. Si s'ha obert, segueix amb el procés i la mostra.
        If gestioIncidencies.IsLoaded = False Then
            gestioIncidencies = New GestioIncidencies
        End If

        gestioIncidencies.Owner = Me
        gestioIncidencies.Show()
        gestioIncidencies.Focus()
        gestioIncidencies.WindowState = Windows.WindowState.Normal

    End Sub

    'Informes Estat
    Private Sub PantallaInformesEstat(ByVal sender As Object, ByVal e As EventArgs) _
    Handles mnuInfEstat.Click

        'Si no s'ha obert la finestra, crea una nova instància. Si s'ha obert, segueix amb el procés i la mostra.
        If informes.IsLoaded = False Then
            informes = New PantallaInformes
        End If

        informes.NomInforme = "IncidenciesPerEstat.rdlc"

        informes.Owner = Me
        informes.Show()
        informes.Focus()
        informes.WindowState = Windows.WindowState.Normal

    End Sub

    'Informes Estat
    Private Sub PantallaInformesSistema(ByVal sender As Object, ByVal e As EventArgs) _
    Handles mnuInfSistema.Click

        'Si no s'ha obert la finestra, crea una nova instància. Si s'ha obert, segueix amb el procés i la mostra.
        If informes2.IsLoaded = False Then
            informes2 = New PantallaInformes
        End If

        informes2.NomInforme = "IncidenciesPerSistema.rdlc"

        informes2.Owner = Me
        informes2.Show()
        informes2.Focus()
        informes2.WindowState = Windows.WindowState.Normal

    End Sub

    'Informes Estat
    Private Sub PantallaInformesTecnic(ByVal sender As Object, ByVal e As EventArgs) _
    Handles mnuInfTecnic.Click

        'Si no s'ha obert la finestra, crea una nova instància. Si s'ha obert, segueix amb el procés i la mostra.
        If informes3.IsLoaded = False Then
            informes3 = New PantallaInformes
        End If

        informes3.NomInforme = "IncidenciesPerTecnic.rdlc"

        informes3.Owner = Me
        informes3.Show()
        informes3.Focus()
        informes3.WindowState = Windows.WindowState.Normal


    End Sub

    'A propòsit de
    Private Sub PantallaAProposit(ByVal sender As Object, ByVal e As EventArgs) _
    Handles mnuAprop.Click

        'Si no s'ha obert la finestra, crea una nova instància. Si s'ha obert, segueix amb el procés i la mostra.
        If aproposit.IsLoaded = False Then
            aproposit = New APropositDe
        End If

        aproposit.Owner = Me
        aproposit.Show()
        aproposit.Focus()
        aproposit.WindowState = Windows.WindowState.Normal

    End Sub

End Class
