﻿Imports System.Data

Public Class SistemesEnllumenat

    Private ReadOnly _gestSql As New GestorSql
    Private _dtSistema As New DataTable
    Private _dtTipus As New DataTable

    Private _codSistema As Integer
    Private _codTipus As Integer
    Private _sistema As String
    Private _data_alta As Date
    Private _data_baixa As Date
    Private _usuari_baixa As String
    Private _usuari_alta As String

    Private _taula As String
    Private _camps As String
    Private _valors As String

    Private _campsValors As String

    Private _filtre As String
    Private _ordre As String

    Private _select As String

    Public Property codSistema() As Integer
        Get
            Return _codSistema
        End Get
        Set(ByVal value As Integer)
            _codSistema = value
        End Set
    End Property

    Public Property codTipus() As Integer
        Get
            Return _codTipus
        End Get
        Set(ByVal value As Integer)
            _codTipus = value
        End Set
    End Property

    Public Property Sistema() As String
        Get
            Return _sistema
        End Get
        Set(ByVal value As String)
            _sistema = value
        End Set
    End Property

    Public Property Data_Alta() As Date
        Get
            Return _data_alta
        End Get
        Set(ByVal value As Date)
            _data_alta = value
        End Set
    End Property

    Public Property Data_Baixa() As Date
        Get
            Return _data_baixa
        End Get
        Set(ByVal value As Date)
            _data_baixa = value
        End Set
    End Property

    Public Property Usuari_Baixa() As String
        Get
            Return _usuari_baixa
        End Get
        Set(ByVal value As String)
            _usuari_baixa = value
        End Set
    End Property

    Public Property Usuari_Alta() As String
        Get
            Return _usuari_alta
        End Get
        Set(ByVal value As String)
            _usuari_alta = value
        End Set
    End Property

    Public Function ObtenirSistema(Optional ByVal sFiltreSist As String = "", _
                                   Optional ByVal sFiltreTipus As String = "") As DataTable

        _filtre = ""
        If sFiltreSist <> "" Then
            _filtre = " Where " & sFiltreSist
        End If

        If sFiltreTipus <> "" Then
            If _filtre = "" Then
                _filtre = " Where " & sFiltreTipus
            Else
                _filtre = " and " & sFiltreTipus
            End If
        End If

        _select = "SELECT distinct s.codSistema,s.sistema,t.tipus,s.data_alta,s.data_baixa,s.usuari_baixa " & _
                  "FROM SistemesEnllumenat s INNER JOIN TipusSistema t " & _
                  "ON s.codTipus = t.codTipus" & _filtre & " " & _
                  "ORDER BY s.codSistema,s.sistema "

        _dtSistema = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtSistema

    End Function

    Public Function ObtenirTipusCbo() As DataTable

        _select = "SELECT distinct s.codTipus, t.tipus " & _
                  "FROM SistemesEnllumenat s INNER JOIN TipusSistema t " & _
                  "ON s.codTipus = t.codTipus " & _
                  "ORDER BY codTipus, tipus "

        _dtTipus = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtTipus

    End Function

    Public Function ObtenirSistemaCbo(Optional ByVal sFiltre As String = "") As DataTable

        _filtre = ""

        If sFiltre <> "" Then
            _filtre = "Where " & sFiltre
        End If

        _select = "SELECT distinct codSistema, sistema " & _
                  "FROM SistemesEnllumenat " & _filtre & " " & _
                  "ORDER BY codSistema, sistema "

        _dtSistema = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtSistema

    End Function

    'Carrega un Sistema pel seu codi
    Public Sub Buscar(ByVal idSistema As Integer)

        _taula = "SistemesEnllumenat"
        _camps = "*"
        _filtre = "codSistema=" & idSistema

        _dtSistema = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)


        'Comprovem si hi ha registres
        If _dtSistema.Rows.Count > 0 Then
            Carregar()
        Else
            Buidar()
        End If

    End Sub

    Private Sub Carregar()

        With _dtSistema.Rows(0)
            _codSistema = .Item("codSistema")
            _codTipus = .Item("codTipus")
            _sistema = .Item("sistema")
            _data_alta = .Item("data_alta")
            _data_baixa = IIf(IsDBNull(.Item("data_baixa")), DateTime.MinValue, .Item("data_baixa"))
            _usuari_baixa = IIf(IsDBNull(.Item("usuari_baixa")), "", .Item("usuari_baixa"))
            _usuari_alta = IIf(IsDBNull(.Item("usuari_alta")), "", .Item("usuari_alta"))

        End With

    End Sub

    Private Sub Buidar()
        _codSistema = 0
        _codTipus = 0
        _sistema = ""
        _data_alta = DATA_NULL
        _usuari_baixa = ""
        _data_baixa = DATA_NULL

    End Sub

    'Gravem les dades del sistema. 
    'Si el cod. sistema és 0 serà un alta nova i si és diferent de 0 serà una modificació
    Public Sub Gravar()

        _taula = "SistemesEnllumenat"

        'Alta
        If _codSistema = 0 Then

            _camps = "sistema,codTipus,data_alta,data_baixa,usuari_baixa,usuari_alta "

            _valors = _
              "'" & _sistema & "','" & _codTipus & "','" & _data_alta & "',Null,Null," & _usuari_alta

            _codSistema = _gestSql.AfegirId(_taula, _camps, _valors)
        Else
            'Modificació 
            _filtre = "codSistema=" & _codSistema
            _campsValors = "sistema='" & _sistema & "', codTipus='" & _codTipus & "', " & _
            "data_baixa='" & IIf(DateTime.Compare(_data_baixa, DateTime.MinValue) = 0, _
                                                         "", _data_baixa) & _
            "' ,usuari_baixa='" & _usuari_baixa & "' "

            _gestSql.Modificar(_taula, _campsValors, _filtre)

        End If

    End Sub

    'Posem data de baixa a un sistema d'enllumenat
    Public Sub Esborrar(ByVal idSistema As Integer)

        _taula = "SistemesEnllumenat"
        _camps = "data_baixa='" & DateTime.Now.Date & "', usuari_baixa='" & usuariAct.Login & "' "
        _filtre = "codSistema=" & idSistema
        _gestSql.Modificar(_taula, _camps, _filtre)

    End Sub

    Public Function DadaExistent(ByVal sCamp As String, _
                                 ByVal sValor As String) As Boolean

        Dim dtTemp As DataTable

        _taula = "SistemesEnllumenat"
        _camps = sCamp
        _filtre = sCamp & "=" & sValor & " and codSistema<>" & _codSistema

        dtTemp = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        'Comprovem si hi ha dades
        If dtTemp.Rows.Count > 0 Then
            Return True
        Else
            Return False
        End If

    End Function

    Public Function EsBaixa() As Boolean

        Dim dtTemp As DataTable

        _taula = "SistemesEnllumenat"
        _camps = "data_baixa"
        _filtre = "codSistema=" & _codSistema

        dtTemp = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        'Comprovem la data de baixa
        If dtTemp.Rows(0)(0).ToString <> "" Then
            Return True
        Else
            Return False
        End If

    End Function

End Class
