﻿Imports System.Data

Public Class TipusSistema

    Private ReadOnly _gestSql As New GestorSql
    Private _dtTipus As New DataTable

    Private _codTipus As Integer
    Private _tipus As String
    Private _detall As String
    Private _data_alta As Date
    Private _data_baixa As Date
    Private _usuari_baixa As String
    Private _usuari_alta As String

    Private _taula As String
    Private _camps As String
    Private _valors As String

    Private _campsValors As String

    Private _filtre As String
    Private _ordre As String

    Private _select As String

    Public Property codTipus() As Integer
        Get
            Return _codTipus
        End Get
        Set(ByVal value As Integer)
            _codTipus = value
        End Set
    End Property

    Public Property Tipus() As String
        Get
            Return _tipus
        End Get
        Set(ByVal value As String)
            _tipus = value
        End Set
    End Property

    Public Property Detall() As String
        Get
            Return _detall
        End Get
        Set(ByVal value As String)
            _detall = value
        End Set
    End Property

    Public Property Data_Alta() As Date
        Get
            Return _data_alta
        End Get
        Set(ByVal value As Date)
            _data_alta = value
        End Set
    End Property

    Public Property Data_Baixa() As Date
        Get
            Return _data_baixa
        End Get
        Set(ByVal value As Date)
            _data_baixa = value
        End Set
    End Property

    Public Property Usuari_Baixa() As String
        Get
            Return _usuari_baixa
        End Get
        Set(ByVal value As String)
            _usuari_baixa = value
        End Set
    End Property

    Public Property Usuari_Alta() As String
        Get
            Return _usuari_alta
        End Get
        Set(ByVal value As String)
            _usuari_alta = value
        End Set
    End Property

    Public Function ObtenirTipus(Optional ByVal sFiltre As String = "") As DataTable

        _taula = "TipusSistema"

        _filtre = ""
        If sFiltre <> "" Then
            _filtre = "Where " & sFiltre
        End If

        _select = "SELECT distinct codTipus,tipus,detall,data_alta,data_baixa,usuari_baixa " & _
                  "FROM TipusSistema " & _filtre & " " & _
                  "ORDER BY codTipus,tipus "

        _dtTipus = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtTipus

    End Function

    Public Function ObtenirTipusCbo(Optional ByVal sFiltre As String = "") As DataTable

        If sFiltre <> "" Then
            sFiltre = "Where " & sFiltre
        End If

        _select = "SELECT distinct codTipus, tipus " & _
                  "FROM TipusSistema " & sFiltre & " " & _
                  "ORDER BY codTipus, tipus "

        _dtTipus = _gestSql.ExecutarSql(_select).Tables(0)

        Return _dtTipus

    End Function

    'Carrega un Tipus pel seu codi
    Public Sub Buscar(ByVal idTipus As Integer)

        _taula = "TipusSistema"
        _camps = "*"
        _filtre = "codTipus=" & idTipus

        _dtTipus = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)


        'Comprovem si hi ha registres
        If _dtTipus.Rows.Count > 0 Then
            Carregar()
        Else
            Buidar()
        End If

    End Sub

    Private Sub Carregar()

        With _dtTipus.Rows(0)
            _codTipus = .Item("codTipus")
            _tipus = .Item("tipus")
            _detall = .Item("detall")
            _data_alta = .Item("data_alta")
            _data_baixa = IIf(IsDBNull(.Item("data_baixa")), DateTime.MinValue, .Item("data_baixa"))
            _usuari_baixa = IIf(IsDBNull(.Item("usuari_baixa")), "", .Item("usuari_baixa"))
            _usuari_alta = IIf(IsDBNull(.Item("usuari_alta")), "", .Item("usuari_alta"))

        End With

    End Sub

    Private Sub Buidar()
        _codTipus = 0
        _tipus = ""
        _detall = ""
        _data_alta = DATA_NULL
        _usuari_baixa = ""
        _data_baixa = DATA_NULL

    End Sub

    'Gravem les dades del tipus. 
    'Si el cod. tipus és 0 serà un alta nova i si és diferent de 0 serà una modificació
    Public Sub Gravar()

        _taula = "TipusSistema"

        'Alta
        If _codTipus = 0 Then

            _camps = "tipus,detall,data_alta,data_baixa,usuari_baixa,usuari_alta "

            _valors = _
              "'" & _tipus & "','" & _detall & "','" & _data_alta & "',Null,Null," & _usuari_alta

            _codTipus = _gestSql.AfegirId(_taula, _camps, _valors)
        Else
            'Modificació 
            _filtre = "codTipus=" & _codTipus
            _campsValors = "tipus='" & _tipus & "', detall='" & _detall & "', " & _
            "data_baixa='" & IIf(DateTime.Compare(_data_baixa, DateTime.MinValue) = 0, _
                                                         "", _data_baixa) & _
            "' ,usuari_baixa='" & _usuari_baixa & "' "

            _gestSql.Modificar(_taula, _campsValors, _filtre)

        End If

    End Sub

    'Posem data de baixa a un tipus de sistema
    Public Sub Esborrar(ByVal idTipus As Integer)

        _taula = "TipusSistema"
        _camps = "data_baixa='" & DateTime.Now.Date & "', usuari_baixa='" & usuariAct.Login & "' "
        _filtre = "codTipus=" & idTipus
        _gestSql.Modificar(_taula, _camps, _filtre)

    End Sub

    Public Function DadaExistent(ByVal sCamp As String, _
                                 ByVal sValor As String) As Boolean

        Dim dtTemp As DataTable

        _taula = "TipusSistema"
        _camps = sCamp
        _filtre = sCamp & "=" & sValor & " and codTipus<>" & _codTipus

        dtTemp = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        'Comprovem si hi ha dades
        If dtTemp.Rows.Count > 0 Then
            Return True
        Else
            Return False
        End If

    End Function

    Public Function EsBaixa() As Boolean

        Dim dtTemp As DataTable

        _taula = "TipusSistema"
        _camps = "usuari_baixa"
        _filtre = "codTipus=" & _codTipus

        dtTemp = _gestSql.ExecutarSql(_taula, _camps, _filtre).Tables(0)

        'Comprovem la data de baixa
        If dtTemp.Rows(0)(0).ToString <> "" Then
            Return True
        Else
            Return False
        End If

    End Function

End Class
